/*********************************************************************************/
/********** THIS FILE IS GENERATED BY TOUCHGFX DESIGNER, DO NOT MODIFY ***********/
/*********************************************************************************/
#include <gui_generated/main_screen/MainViewBase.hpp>
#include <touchgfx/Color.hpp>
#include <BitmapDatabase.hpp>
#include <texts/TextKeysAndLanguages.hpp>

MainViewBase::MainViewBase() :
    buttonCallback(this, &MainViewBase::buttonCallbackHandler)
{

    __background.setPosition(0, 0, 480, 272);
    __background.setColor(touchgfx::Color::getColorFromRGB(0, 0, 0));

    backgroundImage.setXY(0, 0);
    backgroundImage.setBitmap(touchgfx::Bitmap(BITMAP_BG_ID));

    counterBackgroundImage.setXY(0, 59);
    counterBackgroundImage.setBitmap(touchgfx::Bitmap(BITMAP_COUNTER_BOX_ID));

    minTxt.setPosition(0, 92, 152, 89);
    minTxt.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
    minTxt.setLinespacing(0);
    Unicode::snprintf(minTxtBuffer, MINTXT_SIZE, "%s", touchgfx::TypedText(T___SINGLEUSE_93GD).getText());
    minTxt.setWildcard(minTxtBuffer);
    minTxt.setTypedText(touchgfx::TypedText(T_TEXTID1));

    buttonMinUp.setXY(11, 0);
    buttonMinUp.setBitmaps(touchgfx::Bitmap(BITMAP_UP_BTN_ID), touchgfx::Bitmap(BITMAP_UP_BTN_PRESSED_ID));
    buttonMinUp.setAction(buttonCallback);

    buttonMinDown.setXY(11, 216);
    buttonMinDown.setBitmaps(touchgfx::Bitmap(BITMAP_DOWN_BTN_ID), touchgfx::Bitmap(BITMAP_DOWN_BTN_PRESSED_ID));
    buttonMinDown.setAction(buttonCallback);

    buttonStart.setXY(310, 56);
    buttonStart.setBitmaps(touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_SMALL_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_SMALL_PRESSED_ID));
    buttonStart.setLabelText(touchgfx::TypedText(T_RESOURCEID1));
    buttonStart.setLabelColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
    buttonStart.setLabelColorPressed(touchgfx::Color::getColorFromRGB(255, 255, 255));
    buttonStart.setAction(buttonCallback);

    buttonReset.setXY(310, 156);
    buttonReset.setBitmaps(touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_SMALL_ID), touchgfx::Bitmap(BITMAP_BLUE_BUTTONS_ROUND_EDGE_SMALL_PRESSED_ID));
    buttonReset.setLabelText(touchgfx::TypedText(T___SINGLEUSE_SZA8));
    buttonReset.setLabelColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
    buttonReset.setLabelColorPressed(touchgfx::Color::getColorFromRGB(255, 255, 255));
    buttonReset.setAction(buttonCallback);

    counterBackgroundImage_1.setXY(158, 59);
    counterBackgroundImage_1.setBitmap(touchgfx::Bitmap(BITMAP_COUNTER_BOX_ID));

    secTxt.setPosition(158, 92, 152, 89);
    secTxt.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
    secTxt.setLinespacing(0);
    Unicode::snprintf(secTxtBuffer, SECTXT_SIZE, "%s", touchgfx::TypedText(T___SINGLEUSE_81OI).getText());
    secTxt.setWildcard(secTxtBuffer);
    secTxt.setTypedText(touchgfx::TypedText(T_TEXTID1));

    buttonSecUp.setXY(169, 0);
    buttonSecUp.setBitmaps(touchgfx::Bitmap(BITMAP_UP_BTN_ID), touchgfx::Bitmap(BITMAP_UP_BTN_PRESSED_ID));
    buttonSecUp.setAction(buttonCallback);

    buttonSecDown.setXY(169, 216);
    buttonSecDown.setBitmaps(touchgfx::Bitmap(BITMAP_DOWN_BTN_ID), touchgfx::Bitmap(BITMAP_DOWN_BTN_PRESSED_ID));
    buttonSecDown.setAction(buttonCallback);

    textColumn.setXY(147, 92);
    textColumn.setColor(touchgfx::Color::getColorFromRGB(255, 255, 255));
    textColumn.setLinespacing(0);
    textColumn.setTypedText(touchgfx::TypedText(T___SINGLEUSE_91EM));

    add(__background);
    add(backgroundImage);
    add(counterBackgroundImage);
    add(minTxt);
    add(buttonMinUp);
    add(buttonMinDown);
    add(buttonStart);
    add(buttonReset);
    add(counterBackgroundImage_1);
    add(secTxt);
    add(buttonSecUp);
    add(buttonSecDown);
    add(textColumn);
}

void MainViewBase::setupScreen()
{

}

void MainViewBase::buttonCallbackHandler(const touchgfx::AbstractButton& src)
{
    if (&src == &buttonMinUp)
    {
        //IncreaseMinValue
        //When buttonMinUp clicked call virtual function
        //Call increaseMinValue
        increaseMinValue();
    }
    else if (&src == &buttonMinDown)
    {
        //DecreaseMinValue
        //When buttonMinDown clicked call virtual function
        //Call decreaseMinValue
        decreaseMinValue();
    }
    else if (&src == &buttonStart)
    {
        //Start
        //When buttonStart clicked call virtual function
        //Call start
        start();
    }
    else if (&src == &buttonReset)
    {
        //Reset
        //When buttonReset clicked call virtual function
        //Call reset
        reset();
    }
    else if (&src == &buttonSecUp)
    {
        //IncreaseSecValue
        //When buttonSecUp clicked call virtual function
        //Call increaseSecValue
        increaseSecValue();
    }
    else if (&src == &buttonSecDown)
    {
        //DecreaseSecValue
        //When buttonSecDown clicked call virtual function
        //Call decreaseSecValue
        decreaseSecValue();
    }
}
